> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.schoolset.io/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.schoolset.io/_mcp/server.

# Create a registration requirement

POST https://ssuccessv2.com/app/api/v2/registration/setup/create
Content-Type: application/json

Creates a custom file, checkbox, document template, or form requirement for an academic year.

Reference: https://docs.schoolset.io/api-reference/school-set-api/registration-setup/create-registration-requirement

## Authentication

- `Authorization` header (bearer token, required) — The signed-in SchoolSet user token sent by the frontend.

## Request

### Body (application/json)

This endpoint expects an object.

- `batch_id` (integer, required)
- `registration_phase_id` (integer, optional)
- `name` (string, optional, nullable)
- `description` (string, optional, nullable)
- `requirement_details` (map from string to any, optional, nullable)
- `is_required` (boolean, optional)
- `is_editable` (boolean, optional)
- `is_public` (boolean, optional)
- `relates_to` (enum, optional, nullable)
  - Allowed values: `student`, `family`
- `sort_order` (integer, optional)
- `type` (enum, optional)
  - Allowed values: `file`, `checkbox`, `system`, `document_template`, `form`
- `file` (integer, optional, nullable)
- `file_category_id` (integer, optional, nullable)
- `document_template` (integer, optional, nullable)
- `form_id` (integer, optional, nullable)

## Response

### 200

Registration requirement created

- `status` (string, required)
- `message` (string, required)
- `data` (map from string to any, required)

## Errors

### 401 Unauthorized Error

Authentication is required

- `status` (string, required)
- `message` (string, required)
- `data` (any, optional, nullable)

### 403 Forbidden Error

Registration settings editing permission is required

- `status` (string, required)
- `message` (string, required)
- `data` (any, optional, nullable)

### 404 Not Found Error

A referenced file

- `status` (string, required)
- `message` (string, required)
- `data` (any, optional, nullable)

### 422 Unprocessable Entity Error

Requirement fields failed validation

- `message` (string, required)
- `errors` (map from string to list of string, required)

## Examples

**Request**

```json
{
  "batch_id": 2026,
  "registration_phase_id": 4,
  "name": "Proof of address",
  "description": "Upload a current proof of address.",
  "is_public": true,
  "relates_to": "family",
  "type": "file",
  "file_category_id": 6
}
```

**Response**

```json
{
  "status": "success",
  "message": "Created successfully.",
  "data": {
    "id": 412,
    "batch_id": 2026,
    "type": "file",
    "name": "Proof of address",
    "is_required": false,
    "attachments": [],
    "document_templates": []
  }
}
```

**SDK Code**

```python
import requests

url = "https://ssuccessv2.com/app/api/v2/registration/setup/create"

payload = {
    "batch_id": 2026,
    "registration_phase_id": 4,
    "name": "Proof of address",
    "description": "Upload a current proof of address.",
    "is_public": True,
    "relates_to": "family",
    "type": "file",
    "file_category_id": 6
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://ssuccessv2.com/app/api/v2/registration/setup/create';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"batch_id":2026,"registration_phase_id":4,"name":"Proof of address","description":"Upload a current proof of address.","is_public":true,"relates_to":"family","type":"file","file_category_id":6}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://ssuccessv2.com/app/api/v2/registration/setup/create"

	payload := strings.NewReader("{\n  \"batch_id\": 2026,\n  \"registration_phase_id\": 4,\n  \"name\": \"Proof of address\",\n  \"description\": \"Upload a current proof of address.\",\n  \"is_public\": true,\n  \"relates_to\": \"family\",\n  \"type\": \"file\",\n  \"file_category_id\": 6\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://ssuccessv2.com/app/api/v2/registration/setup/create")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"batch_id\": 2026,\n  \"registration_phase_id\": 4,\n  \"name\": \"Proof of address\",\n  \"description\": \"Upload a current proof of address.\",\n  \"is_public\": true,\n  \"relates_to\": \"family\",\n  \"type\": \"file\",\n  \"file_category_id\": 6\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://ssuccessv2.com/app/api/v2/registration/setup/create")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"batch_id\": 2026,\n  \"registration_phase_id\": 4,\n  \"name\": \"Proof of address\",\n  \"description\": \"Upload a current proof of address.\",\n  \"is_public\": true,\n  \"relates_to\": \"family\",\n  \"type\": \"file\",\n  \"file_category_id\": 6\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://ssuccessv2.com/app/api/v2/registration/setup/create', [
  'body' => '{
  "batch_id": 2026,
  "registration_phase_id": 4,
  "name": "Proof of address",
  "description": "Upload a current proof of address.",
  "is_public": true,
  "relates_to": "family",
  "type": "file",
  "file_category_id": 6
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://ssuccessv2.com/app/api/v2/registration/setup/create");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"batch_id\": 2026,\n  \"registration_phase_id\": 4,\n  \"name\": \"Proof of address\",\n  \"description\": \"Upload a current proof of address.\",\n  \"is_public\": true,\n  \"relates_to\": \"family\",\n  \"type\": \"file\",\n  \"file_category_id\": 6\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "batch_id": 2026,
  "registration_phase_id": 4,
  "name": "Proof of address",
  "description": "Upload a current proof of address.",
  "is_public": true,
  "relates_to": "family",
  "type": "file",
  "file_category_id": 6
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://ssuccessv2.com/app/api/v2/registration/setup/create")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```